#   adc3214v.defn.tcl     Ganil ADC 32 channel 14 bit  VXI card

#    based on QDC module

#    load address definitions

loadsource GroupDefn

proc {AddADC3214VModule}  {module slot}  {
   global registerbase namebase cardtype 

   set registerbase $cardtype$module
   set namebase $cardtype$module

   delete-vxi-registers $registerbase.*

   ADC3214VVXIRegisters $slot
   ADC3214VModuleRegisters  $slot

   for {set c 0} {$c < 32} {incr c} {

        set registerbase $cardtype$module.c$c
       
        ADC3214VChannelRegisters $slot $c
   }
}

proc adc3214_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc ADC3214VVXIRegisters {slot} {
   adc3214_register     VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   adc3214_register     VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   adc3214_register     VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   adc3214_register     VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   adc3214_register     VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   adc3214_register     VXI.Status     xSht   "-s$slot -o4  -pro -w16 -fx"
   adc3214_register     VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   adc3214_register     VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   adc3214_register     VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   adc3214_register     VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   adc3214_register     VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   adc3214_register     VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   adc3214_register     VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   adc3214_register     VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
   adc3214_register     Termination    xSht   "-s$slot -o4  -prw -w16 -fd -b6 -l2 -i3"
}

proc ADC3214VModuleRegisters {slot} {
   adc3214_register  VXLOGADD   xSht   "-s$slot -o0 -pwo -w16"
   adc3214_register  VXCONTRL   xSht   "-s$slot -o4 -pwo -w16"
   adc3214_register  VXCONTRL.MP   xSht   "-s$slot -o4 -prw -w16 -fd -b9 -l1"
   adc3214_register  VXCONTRL.ZP   xSht   "-s$slot -o4 -prw -w16 -fd -b8 -l1"

   adc3214_register  VXMSKVOIE0  xDig  "-s$slot -c0 -o0x0004 -w16 -prw -fx -b0 -l0 -i255"
   adc3214_register  VXMSKVOIE1  xDig  "-s$slot -c0 -o0x0804 -w16 -prw -fx -b0 -l0 -i255"
   adc3214_register  VXMSKVOIE2  xDig  "-s$slot -c0 -o0x1004 -w16 -prw -fx -b0 -l0 -i255"
   adc3214_register  VXMSKVOIE3  xDig  "-s$slot -c0 -o0x1804 -w16 -prw -fx -b0 -l0 -i255"

   adc3214_register  VXSTATUS    xDig  "-s$slot -c0 -o0x0010 -w16 -prw -fx -b0 -l0 -i0x72f1"

   adc3214_register  VXNIVTEST1    xDig  "-s$slot -c0 -o0x0060 -w16 -prw  -b0 -l0 -i0x0"
   adc3214_register  VXNIVPV1    xDig  "-s$slot -c0 -o0x0062 -w16 -prw  -b0 -l0 -i0x0"
   adc3214_register  VXNIVA1   xDig  "-s$slot -c0 -o0x0064 -w16 -prw  -b0 -l0 -i0x0"
   adc3214_register  VXNIVB1    xDig  "-s$slot -c0 -o0x0066 -w16 -prw  -b0 -l0 -i0x0"
   adc3214_register  VXNIVTEST2    xDig  "-s$slot -c0 -o0x0068 -w16 -prw  -b0 -l0 -i0x0"
   adc3214_register  VXNIVPV2    xDig  "-s$slot -c0 -o0x006a -w16 -prw  -b0 -l0 -i0x0"
   adc3214_register  VXNIVA2   xDig  "-s$slot -c0 -o0x006c -w16 -prw  -b0 -l0 -i0x0"
   adc3214_register  VXNIVB2    xDig  "-s$slot -c0 -o0x006e -w16 -prw  -b0 -l0 -i0x0"

   adc3214_register  VXSYNCTST  xSht  "-s$slot -o0x32 -w16 -prw -b0 -l0 -i0x8001"
   adc3214_register  VXVAL      xSht  "-s$slot -o0x30 -w16 -prw -b0 -l0 -i0x8000"
   adc3214_register  VXINIT     xSht  "-s$slot -o0x24 -w16 -prw -b0 -l0 -i0x8003"
   adc3214_register  VXWORK     xSht  "-s$slot -o0x26 -w16 -prw -b0 -l0 -i0x8004"
   adc3214_register  VXINHIBIT  xSht  "-s$slot -o0x2e -w16 -prw -b0 -l0 -i0x8007"
   adc3214_register  VXCT       xSht  "-s$slot -o0x2a -w16 -prw -b0 -l0 -i0x8006"
   adc3214_register  VXMRST     xSht  "-s$slot -o0x28 -w16 -prw -b0 -l0 -i0x8005"
   adc3214_register  VXCODING   xSht  "-s$slot -o0x20 -w16 -prw -b0 -l0 -i0x8000"
   adc3214_register  VXREADOUT  xSht  "-s$slot -o0x22 -w16 -prw -b0 -l0 -i0x8001"

   adc3214_register  VXSIGLI1 xDig  "-s$slot -c0 -o0x00d0 -w16 -pwo -b0 -l0"
   adc3214_register  VXSIGLI2 xDig  "-s$slot -c0 -o0x00d2 -w16 -pwo -b0 -l0"
}

set VXMSKAddressTable {0x0004 0x0804 0x1004 0x1804}
for {set c 0} {$c < 32} {incr c} {set ADC3214VDataBits(c$c) 14}

proc ADC3214VChannelRegisters {slot c} {
   global namebase VXMSKAddressTable DataBits

   adc3214_register  Addr   xAdr  "-s$slot -c$c -o0x00 -w16 -prw -fx -b0 -l0 -i$namebase.Adc$c"

   set group [expr $c / 8]
   set entry [expr  $c - [expr $group * 8]]
   set address [lindex $VXMSKAddressTable $group]
   adc3214_register  Enable  xDig  "-s$slot -c0 -o$address -w16 -prw -fd -b$entry -l1"

   adc3214_register  VXLTVOIE  xDig  "-s$slot -c$c -o0xc4 -w16 -pwo -b0 -l0"
   adc3214_register  VXLI1VOIE xDig  "-s$slot -c$c -o0xc0 -w16 -pwo -b0 -l0"
   adc3214_register  VXLI2VOIE xDig  "-s$slot -c$c -o0xc2 -w16 -pwo -b0 -l0"
   adc3214_register  VXAIVOIE xDig  "-s$slot -c$c -o0xc6 -w16 -pwo -b0 -l0"
}



proc {ADC3214V_DAQ-reset}  {args}  {
#    Ganil ADC 32 channel 14 bit module
  global ADC3214VBase
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 1
}

proc {ADC3214V_DAQ-setup}  {args}  {
#    Ganil ADC 32 channel 14 bit module
  set module [first $args]
}

proc {ADC3214V_DAQ-go}  {args}  {
#    Ganil ADC 32 channel 12 bit module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 0
  write-vxi-register $module.VXCONTRL.ZP 1
}

proc {ADC3214V_DAQ-halt}  {args}  {
#    Ganil ADC 32 channel 12 bit module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 1
}
