

#   adc6414v.defn.tcl     Ganil ADC 64 channel 14 bit  VXI card

#    load address definitions

loadsource GroupDefn

proc {AddADC6414VModule}  {module slot}  {
   global registerbase namebase cardtype 

   set registerbase $cardtype$module
   set namebase $cardtype$module

   delete-vxi-registers $registerbase.*

   ADC6414VVXIRegisters $slot
   ADC6414VModuleRegisters  $slot

   for {set c 0} {$c < 64} {incr c} {

        set registerbase $cardtype$module.c$c
       
        ADC6414VChannelRegisters $slot $c
   }
}

proc adc6414_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc ADC6414VVXIRegisters {slot} {
   adc6414_register     VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   adc6414_register     VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   adc6414_register     VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   adc6414_register     VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   adc6414_register     VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   adc6414_register     VXI.Status     xSht   "-s$slot -o4  -pro -w16 -fx"
   adc6414_register     VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   adc6414_register     VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   adc6414_register     VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   adc6414_register     VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   adc6414_register     VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   adc6414_register     VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   adc6414_register     VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   adc6414_register     VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
   adc6414_register     LastCard       xSht   "-s$slot -o4  -prw -w16 -fd -b4 -l1"
}

proc ADC6414VModuleRegisters {slot} {
   adc6414_register  VXLOGADD   xSht   "-s$slot -o0 -pwo -w16"
   adc6414_register  VXCONTRL   xSht   "-s$slot -o4 -pwo -w16"
   adc6414_register  VXCONTRL.MP   xSht   "-s$slot -o4 -prw -w16 -fd -b9 -l1"
   adc6414_register  VXCONTRL.ZP   xSht   "-s$slot -o4 -prw -w16 -fd -b8 -l1"

   adc6414_register  VXMSKVOIE0  xDig  "-s$slot -c0 -o0x0004 -w16 -prw -fx -b0 -l0 -i255"
   adc6414_register  VXMSKVOIE1  xDig  "-s$slot -c0 -o0x0804 -w16 -prw -fx -b0 -l0 -i255"
   adc6414_register  VXMSKVOIE2  xDig  "-s$slot -c0 -o0x1004 -w16 -prw -fx -b0 -l0 -i255"
   adc6414_register  VXMSKVOIE3  xDig  "-s$slot -c0 -o0x1804 -w16 -prw -fx -b0 -l0 -i255"
   adc6414_register  VXMSKVOIE4  xDig  "-s$slot -c0 -o0x2004 -w16 -prw -fx -b0 -l0 -i255"
   adc6414_register  VXMSKVOIE5  xDig  "-s$slot -c0 -o0x2804 -w16 -prw -fx -b0 -l0 -i255"
   adc6414_register  VXMSKVOIE6  xDig  "-s$slot -c0 -o0x3004 -w16 -prw -fx -b0 -l0 -i255"
   adc6414_register  VXMSKVOIE7  xDig  "-s$slot -c0 -o0x3804 -w16 -prw -fx -b0 -l0 -i255"

   adc6414_register  VXETAT1    xDig  "-s$slot -c0 -o0x0010 -w16 -prw -fx -b0 -l0 -i0x004d"
   adc6414_register  VXTEMP1    xDig  "-s$slot -c0 -o0x0060 -w16 -pwo  -b0 -l0 -i0x0800"
   adc6414_register  VXTEMP2    xDig  "-s$slot -c0 -o0x0062 -w16 -pwo  -b0 -l0 -i0x0800"
   adc6414_register  VXAMPTST   xDig  "-s$slot -c0 -o0x0052 -w16 -pwo  -b0 -l0 -i0x0"
   adc6414_register  VXSEUIL    xDig  "-s$slot -c0 -o0x0050 -w16 -pwo  -b0 -l0 -i0x0"

   adc6414_register  VXSYNCTST  xSht  "-s$slot -o0x20 -w16 -pwo -b0 -l0 -i0x8001"
   adc6414_register  VXINIT     xSht  "-s$slot -o0x22 -w16 -pwo -b0 -l0 -i0x8003"
   adc6414_register  VXINHIBIT  xSht  "-s$slot -o0x24 -w16 -pwo -b0 -l0 -i0x8007"
   adc6414_register  VXODC      xSht  "-s$slot -o0x26 -w16 -pwo -b0 -l0 -i0x8006"
   adc6414_register  VXREVT     xSht  "-s$slot -o0x28 -w16 -pwo -b0 -l0 -i0x8005"
   adc6414_register  VXCODAGE   xSht  "-s$slot -o0x2a -w16 -pwo -b0 -l0 -i0x8000"
   adc6414_register  VXLECTURE  xSht  "-s$slot -o0x2c -w16 -pwo -b0 -l0 -i0x8001"

   adc6414_register  VXIL2CARTE xDig  "-s$slot -c0 -o0x00d2 -w16 -pwo -b0 -l0"
   adc6414_register  VXIL3CARTE xDig  "-s$slot -c0 -o0x00dc -w16 -pwo -b0 -l0"
}

set VXMSKAddressTable {0x0004 0x0804 0x1004 0x1804 0x2004 0x2804 0x3004 0x3804}
for {set c 0} {$c < 64} {incr c} {set ADC6414VDataBits(c$c) 14}

proc ADC6414VChannelRegisters {slot c} {
   global namebase VXMSKAddressTable DataBits

   adc6414_register  Addr   xAdr  "-s$slot -c$c -o0x00 -w16 -prw -fx -b0 -l0 -i$namebase.Adc$c"

   set group [expr $c / 8]
   set entry [expr  $c - [expr $group * 8]]
   set address [lindex $VXMSKAddressTable $group]
   adc6414_register  Enable  xDig  "-s$slot -c0 -o$address -w16 -prw -fd -b$entry -l1"

   adc6414_register  VXCFVOIE  xDig  "-s$slot -c$c -o0xc4 -w16 -pwo -b0 -l0"
   adc6414_register  VXIL2VOIE xDig  "-s$slot -c$c -o0xc2 -w16 -pwo -b0 -l0"
   adc6414_register  VXIL3VOIE xDig  "-s$slot -c$c -o0xcc -w16 -pwo -b0 -l0"
}

#    the following proc is equivalent to  register initialise for the module
#    it is here purely for reference
proc {ADC6414V_initialise}  {args}  {
  set module [first $args]

  write-vxi-register $module.VXMSKVOIE0 255
  write-vxi-register $module.VXMSKVOIE1 255
  write-vxi-register $module.VXMSKVOIE2 255
  write-vxi-register $module.VXMSKVOIE3 255
  write-vxi-register $module.VXMSKVOIE4 255
  write-vxi-register $module.VXMSKVOIE5 255
  write-vxi-register $module.VXMSKVOIE6 255
  write-vxi-register $module.VXMSKVOIE7 255

  write-vxi-register $module.VXSYNCTST 0x8001
  write-vxi-register $module.VXINIT 0x8003
  write-vxi-register $module.VXINHIBIT 0x8007
  write-vxi-register $module.VXODC 0x8006
  write-vxi-register $module.VXREVT 0x8005
  write-vxi-register $module.VXCODAGE 0x8000
  write-vxi-register $module.VXLECTURE 0x8001

  write-vxi-register $module.VXETAT1 0x004d
  write-vxi-register $module.VXTEMP1 0x800
  write-vxi-register $module.VXTEMP2 0x800
  write-vxi-register $module.VXAMPTST 0x0
  write-vxi-register $module.VXSEUIL 0x0
}


proc {ADC6414V_DAQ-reset}  {args}  {
#    Ganil ADC 64 channel 14 bit module
  global ADC6414VBase

  set module [first $args]
#    Halt the module
  write-vxi-register $module.VXCONTRL.MP 1
  write-vxi-register $module.VXETAT1 0x004d
}


proc {ADC6414V_DAQ-go}  {args}  {
#    Ganil ADC 64 channel 12 bit module
  set module [first $args]
  write-vxi-register $module.VXETAT1 0x004d
  write-vxi-register $module.VXCONTRL.MP 0
  write-vxi-register $module.VXCONTRL.ZP 1
}

proc {ADC6414V_DAQ-halt}  {args}  {
#    Ganil ADC 64 channel 12 bit module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 1
}
