

#  centrum.defn.tcl     Centrum VXI card

proc {AddCentrumModule}  {module slot}  {
   global registerbase cardtype nsockets
   global file

   set registerbase $cardtype$module
   set file 0

   delete-vxi-registers $registerbase.*

   CentrumVXIRegisters $slot
   CentrumModuleRegisters $slot
}

proc {BuildCentrumModule}  {}  {
   global registerbase
   global file

   set registerbase ""

   set f "centrum.defn.c"

   set z [catch {open $f w} file]
   if {$z != 0} then {return $file}
      
   CentrumVXIRegisters %d
   CentrumModuleRegisters %d
   
   close $file
   return 0
}

proc centrum_register {registername class attributes} {
   global registerbase
   global file
   
   if {$file == 0} {
       define-vxi-register $registerbase $class $registername "$attributes"
   } else {
       if {$registerbase == ""} then {
           puts $file "\{\"$registername\",   \"$class\",  \"$attributes\"\},"
       } else {
           puts $file "\{\"$registerbase.$registername\",   \"$class\",  \"$attributes\"\},"
       }
   }
}

proc CentrumVXIRegisters {slot} {

   centrum_register  datal          xDig "-s$slot -o0x0 -w32 -prw -fx"
   centrum_register  dataw          xDig "-s$slot -o0x0 -w16 -prw -fx"
   centrum_register  datas          xSht "-s$slot -o0x0 -w16 -prw -fx"

   centrum_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   centrum_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   centrum_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   centrum_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   centrum_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   centrum_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   centrum_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   centrum_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   centrum_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   centrum_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   centrum_register  VXI.Status     xSht   "-s$slot -o4  -pro -w16 -fx"
   centrum_register  VXI.Control    xSht   "-s$slot -o4  -pwo -w16 -fx"
   centrum_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   centrum_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   centrum_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"

   centrum_register  VXI.Coding     xSht   "-s$slot -o0x20 -prw -w16 -fx  -b0 -l0 -i0x8000"
   centrum_register  VXI.Readout    xSht   "-s$slot -o0x22 -prw -w16 -fx  -b0 -l0 -i0x8001"
   centrum_register  VXI.Init       xSht   "-s$slot -o0x24 -prw -w16 -fx  -b0 -l0 -i0x8003"
   centrum_register  VXI.Go         xSht   "-s$slot -o0x26 -prw -w16 -fx  -b0 -l0 -i0x8004"
   centrum_register  VXI.MRST       xSht   "-s$slot -o0x28 -prw -w16 -fx  -b0 -l0 -i0x8005"
   centrum_register  VXI.Val        xSht   "-s$slot -o0x2a -prw -w16 -fx  -b0 -l0 -i0x8006"

   centrum_register  INT_EvNumErr   xSht   "-s$slot -o0x34 -prw -w16 -fx"
   centrum_register  INT_TimeOut    xSht   "-s$slot -o0x36 -prw -w16 -fx"
   centrum_register  INT_Miss       xSht   "-s$slot -o0x38 -prw -w16 -fx"
}


proc CentrumModuleRegisters {slot} {
   global registerbase

    centrum_register   config       xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fx"
    centrum_register   config.exo   xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b0 -l1"
    centrum_register   config.ten   xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b1 -l1"
    centrum_register   config.exie  xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b2 -l1"
    centrum_register   config.tie   xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b3 -l1"
    centrum_register   config.cali  xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b4 -l1"
    centrum_register   config.zs    xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b5 -l1"
    centrum_register   config.dt32  xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b6 -l1"
    centrum_register   config.dtf   xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b7 -l1"
    centrum_register   config.mie   xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b8 -l1"
    centrum_register   config.samr  xDig   "-s$slot -a0x0 -o0x0 -prw -w16 -fd -b9 -l1"

    centrum_register   mask         xDig   "-s$slot -a0x0 -o0x2 -prw -w16 -fx"
    centrum_register   mask.rx      xDig   "-s$slot -a0x0 -o0x2 -prw -w16 -fd -b0 -l1"
    foreach i {1 2 3 4 5 6 7} {
        centrum_register   mask.tx$i     xDig   "-s$slot -a0x0 -o0x2 -prw -w16 -fd -b$i -l1"
    }
    centrum_register   mask.aux     xDig   "-s$slot -a0x0 -o0x2 -prw -w16 -fd -b8 -l1"
    foreach i {1 2 3 4 5 6 7} {
        centrum_register   mask.lch$i xDig "-s$slot -a0x0 -o0x2 -prw -w16 -fd -b[expr $i+8] -l1"
    }

    centrum_register   txmode       xDig   "-s$slot -a0x0 -o0x4 -prw -w16 -fx"
    foreach i {1 2 3 4 5 6 7} {
       centrum_register   txmode.cor$i  xDig   "-s$slot -a0x0 -o0x4 -prw -w16 -fd -b[expr $i-1] -l1"
       centrum_register   txmode.sa$i   xDig   "-s$slot -a0x0 -o0x4 -prw -w16 -fd -b[expr $i+7] -l1"
    }

    centrum_register   loadclkl     xDig   "-s$slot -a0x0 -o0x6 -prw -w16 -fx"
    centrum_register   loadclkm     xDig   "-s$slot -a0x0 -o0x8 -prw -w16 -fx"
    centrum_register   loadclkh     xDig   "-s$slot -a0x0 -o0xa -prw -w16 -fx"

    centrum_register   loadtil      xDig   "-s$slot -a0x0 -o0xc -prw -w16 -fx"
    centrum_register   loadtim      xDig   "-s$slot -a0x0 -o0xe -prw -w16 -fx"
    centrum_register   loadtih      xDig   "-s$slot -a0x0 -o0x10 -prw -w16 -fx"

    foreach i {1 2 3 4 5 6 7} {
        centrum_register   deltag$i      xDig   "-s$slot -a0x0 -o[expr 0x10 + $i + $i] -prw -w16 -fx"
    }

    centrum_register   label.evnum.l  xDig   "-s$slot -a0x0 -o0x100 -prw -w16 -fx"
    centrum_register   label.evnum.h  xDig   "-s$slot -a0x0 -o0x102 -prw -w16 -fx"
    centrum_register   label.rx.l   xDig   "-s$slot -a0x0 -o0x104 -prw -w16 -fx"
    centrum_register   label.rx.m   xDig   "-s$slot -a0x0 -o0x106 -prw -w16 -fx"
    centrum_register   label.rx.h   xDig   "-s$slot -a0x0 -o0x108 -prw -w16 -fx"
    foreach i {1 2 3 4 5 6 7} {
       centrum_register   label.tx$i.l       xDig   "-s$slot -a0x0 -o[expr ($i - 1) * 6 + 0x10a] -prw -w16 -fx"
       centrum_register   label.tx$i.m       xDig   "-s$slot -a0x0 -o[expr ($i - 1) * 6 + 0x10c] -prw -w16 -fx"
       centrum_register   label.tx$i.h       xDig   "-s$slot -a0x0 -o[expr ($i - 1) * 6 + 0x10e] -prw -w16 -fx"
    }
    centrum_register   label.miss xDig   "-s$slot -a0x0 -o0x134 -prw -w16 -fx"

    centrum_register   cmd       xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fx"
    centrum_register   cmd.reset xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b0 -l1"
    centrum_register   cmd.evcr  xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b1 -l1"
    centrum_register   cmd.rclk  xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b2 -l1"
    centrum_register   cmd.lclk  xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b3 -l1"
    centrum_register   cmd.ltim  xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b4 -l1"
    centrum_register   cmd.rerr  xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b5 -l1"
    centrum_register   cmd.rtout xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b6 -l1"
    centrum_register   cmd.pull  xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b7 -l1"
    centrum_register   cmd.pul2  xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b8 -l1"
    centrum_register   cmd.uclk  xDig   "-s$slot -a0x0 -o0x20 -prw -w16 -fd -b9 -l1"

    centrum_register   status      xDig   "-s$slot -a0x0 -o0x22 -prw -w16 -fx"
    centrum_register   status.scod xDig   "-s$slot -a0x0 -o0x22 -prw -w16 -fd -b0 -l1"
    centrum_register   status.ecod xDig   "-s$slot -a0x0 -o0x22 -prw -w16 -fd -b1 -l1"
    centrum_register   status.read xDig   "-s$slot -a0x0 -o0x22 -prw -w16 -fd -b2 -l1"
    centrum_register   status.clks xDig   "-s$slot -a0x0 -o0x22 -prw -w16 -fd -b3 -l1"
    centrum_register   status.err  xDig   "-s$slot -a0x0 -o0x22 -prw -w16 -fd -b4 -l1"
    centrum_register   status.tout xDig   "-s$slot -a0x0 -o0x22 -prw -w16 -fd -b5 -l1"

    centrum_register   test1        xDig   "-s$slot -a0x0 -o0x24 -prw -w16 -fd -b0 -l8"
    centrum_register   test2        xDig   "-s$slot -a0x0 -o0x24 -prw -w16 -fd -b8 -l8"
    centrum_register   MissOvf      xDig   "-s$slot -a0x0 -o0x28 -prw -w16 -fd -b0 -l0"

    centrum_register   evcnt       xDig   "-s$slot -a0x0 -o0x30 -pro -w32 -fx"
    centrum_register   MissEvts    xDig   "-s$slot -a0x0 -o0x34 -pro -w32 -fx"

    foreach i {0 1 2 3 4 5 6 7} {
       centrum_register   timeml$i     xDig   "-s$slot -a0x0 -o[expr $i * 8 + 0x44] -pro -w32 -fx"
       centrum_register   timeh$i      xDig   "-s$slot -a0x0 -o[expr $i * 8 + 0x40] -pro -w32 -fx"
    }

    centrum_register   data        xDig   "-s$slot -a0x0 -o0x80 -pro -w32 -fx"
}

proc Centrum_DAQ-setup   {args}   {
   set module [first $args]
#    stop work unit
   write-vxi-register $module.VXI.Control 0xc34f
#    zero event counter
   write-vxi-register $module.cmd.evcr 1
#    exogam + dt32 mode
   write-vxi-register $module.config.dt32 1
   write-vxi-register $module.config.exo 1
}

proc Centrum_DAQ-reset   {args}   {
   set module [first $args]
#    stop work unit
   write-vxi-register $module.VXI.Control 0xc34f
#    zero event counter
   write-vxi-register $module.cmd.evcr 1
#    exogam + dt32 mode
   write-vxi-register $module.config.dt32 1
   write-vxi-register $module.config.exo 1
}

proc Centrum_DAQ-halt   {args}   {
   set module [first $args]
#    stop work unit
   write-vxi-register $module.VXI.Control 0xc34f
}


proc Centrum_DAQ-go   {args}   {
   set module [first $args]
#    zero event counter
   write-vxi-register $module.cmd.evcr 1
#    exogam + dt32 mode
   write-vxi-register $module.config.dt32 1
   write-vxi-register $module.config.exo 1
#    start work unit
   write-vxi-register $module.VXI.Control 0xc14f
}
