

#   qdc6412v.defn.tcl     Ganil QDC 64 channel 12 bit  VXI card

#    data addressing  - for now Group Base is 100

set ItemBase 0
set GroupBase 100

proc {AddQDC6412VModule}  {module slot}  {
   global registerbase cardtype nsockets

   set registerbase $cardtype#$module

   delete-vxi-registers $registerbase.*

   QDC6412VVXIRegisters $slot
   QDC6412VModuleRegisters  $slot

   for {set socket 1} {$socket <= $nsockets} {incr socket} {

        set registerbase $cardtype[expr $module * $nsockets + $socket - 1]

        delete-vxi-registers $registerbase.*

#    first a register to record module each channel is in
        qdc6412_register  ModuleName    generic "-n$cardtype#$module -tstring -pro"
   
        QDC6412VVXIRegisters $slot
        QDC6412VModuleRegisters $slot

        QDC6412VChannelRegisters $slot $socket
   }
}

proc qdc6412_register {class registername attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc QDC6412VVXIRegisters {slot} {
   qdc6412_register xSht     VXI.ManID      "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   qdc6412_register xSht     VXI.AddrSpace  "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   qdc6412_register xSht     VXI.DevClass   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   qdc6412_register xSht     VXI.ModelCode  "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   qdc6412_register xSht     VXI.ReqMem     "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   qdc6412_register xSht     VXI.Reset      "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   qdc6412_register xSht     VXI.Passed     "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   qdc6412_register xSht     VXI.Ready      "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   qdc6412_register xSht     VXI.ModID      "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   qdc6412_register xSht     VXI.A24A32     "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   qdc6412_register xSht     VXI.Offset     "-s$slot -o6  -pro -w16 -fx"
   qdc6412_register xSht     VXI.SerialNum  "-s$slot -o8  -pro -w16 -fx"
   qdc6412_register xSht     VXI.ModLevel   "-s$slot -o10 -pro -w16 -fx"
}

proc QDC6412VModuleRegisters {slot} {
   qdc6412_register  xSht  VXCONTRL      "-s$slot -o4 -pwo -w16 -fx"
   qdc6412_register  xSht  VXCONTRL.MP   "-s$slot -o4 -prw -w16 -fd -b9 -l1"
   qdc6412_register  xSht  VXSTATUS   "-s$slot -o4 -pro -w16 -fx"
   qdc6412_register  xSht  LastCard      "-s$slot -o4 -prw -w16 -fd -b4 -l1"



   qdc6412_register  xDig  VXMSKVOIE0  "-s$slot -c0 -o0x0004 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  VXMSKVOIE1  "-s$slot -c0 -o0x0804 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  VXMSKVOIE2  "-s$slot -c0 -o0x1004 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  VXMSKVOIE3  "-s$slot -c0 -o0x1804 -w16 -prw -fx -b0 -l0"

   qdc6412_register  xDig  VXETAT1    "-s$slot -c0 -o0x0010 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  VXTEMP1    "-s$slot -c0 -o0x0060 -w16 -pwo -fx -b0 -l0"
   qdc6412_register  xDig  VXTEMP2    "-s$slot -c0 -o0x0062 -w16 -pwo -fx -b0 -l0"
   qdc6412_register  xDig  VXAMPTST   "-s$slot -c0 -o0x0052 -w16 -pwo -fx -b0 -l0"

   qdc6412_register  xDig  VXPDTCOM   "-s$slot -c0 -o0x0050 -w16 -prw -fx -b0 -l0"

   qdc6412_register  xDig  VXIL1CARTE "-s$slot -c0 -o0x00d0 -w16 -pwo -fx -b0 -l0"
   qdc6412_register  xDig  VXIL2CARTE "-s$slot -c0 -o0x00d2 -w16 -pwo -fx -b0 -l0"

   qdc6412_register  xDig  VXMTCARTE  "-s$slot -c0 -o0x00da -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  VXBITPAT1  "-s$slot -c0 -o0x0080 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  VXBITPAT2  "-s$slot -c0 -o0x1080 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  VXCPTVOI   "-s$slot -c0 -o0x0090 -w16 -prw -fx -b0 -l0"
}


proc QDC6412VChannelRegisters {slot socket} {

   set c [expr socket - 1]
   qdc6412_register  xAdr  c$channel.VXLABEL1  "-s$slot -c$c -o0x00 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xAdr  c$channel.VXLABEL2  "-s$slot -c$c -o0x02 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  c$channel.VXTSTLB1  "-s$slot -c$c -o0x20 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  c$channel.VXTSTLB2  "-s$slot -c$c -o0x24 -w16 -prw -fx -b0 -l0"
   qdc6412_register  xDig  c$channel.VXCFVOIE  "-s$slot -c$c -o0xc4 -w16 -pwo -fx -b0 -l0"
   qdc6412_register  xDig  c$channel.VXIL1VOIE "-s$slot -c$c -o0xc0 -w16 -pwo -fx -b0 -l0"
   qdc6412_register  xDig  c$channel.VXIL2VOIE "-s$slot -c$c -o0xc2 -w16 -pwo -fx -b0 -l0"
}


proc {QDC6412V_DAQ-reset}  {args}  {
#    Ganil QDC 64 channel 12 bit module
  global ItemBase GroupBase
  global cardtype
  set module [first $args]
#    Halt the module
  write-vxi-register $module.VXCONTRL.MP 1
#    set-up the group and item addresses
#    group is  GroupBase + (module number * 32)
#    items are 0 and 1
  set Group [expr [string range $module [string length $cardtype] end] * 32 + $GroupBase]
  for {set c 0} {$c <= 31} {incr c} {
     set label [expr [expr $ItemBase << 8] +  $Group + $c]
     write-vxi-register $module.c$c.VXLABEL1 $label
  }
  for {set c 0} {$c <= 31} {incr c} {
     set label [expr [expr $ItemBase + 1 << 8] + $Group + $c]
     write-vxi-register $module.c$c.VXLABEL2 $label
  }
#    rest of the initialisation
  write-vxi-register $module.VXMSKVOIE0 255
  write-vxi-register $module.VXMSKVOIE1 255
  write-vxi-register $module.VXMSKVOIE2 255
  write-vxi-register $module.VXMSKVOIE3 255
  write-vxi-register $module.VXETAT1 6
  write-vxi-register $module.VXTEMP1 0x800
  write-vxi-register $module.VXTEMP2 0x800
  write-vxi-register $module.VXAMPTST 0x800
  write-vxi-register $module.VXPDTCOM 0x800
}


proc {QDC6412V_DAQ-go}  {args}  {
#    Ganil QDC 64 channel 12 bit module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 0
}

proc {QDC6412V_DAQ-halt}  {args}  {
#    Ganil QDC 64 channel 12 bit module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 1
}
