#    definitions used by the Cluster BGO VXI setup tasks
#


set chanlist {???}
set chanindex 0
set seglist {Sum A B C D E F G H I J K L M N O P Q R S}
set segindex 0 

set defaultchanlist {0 1 2 3 4 5 6 7}

set cardtype ClusterBGO
set chantype BGO

set VXIGlobal Global

#    The array "table" which is indexed by the "widget name" contains all the information
#    needed for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for regsiter access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"

set table(ALLCHANS) {allchans int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ALLSEGS)  {allsegs  int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ENABLE) {enable int-widget->param param->int-widget "Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Enable"}


set table(FTSAMPLE) { ftsample slider-widget->param param->int-widget "FTSample"
       unit-reg->param param->unit-reg ns :slider 0 3200 12 1 "Fast Trigger Sample (ns)"}
set table(VALSAMPLE) {valsample slider-widget->param param->int-widget "ValSample"
       unit-reg->param param->unit-reg ns :slider 0 16000 64 1 "Validation Sample (ns)"}
set table(VETOADJ) {vetoadj slider-widget->param param->int-widget "VETO"
       unit-reg->param param->unit-reg ns :slider 0 16000 64 1 "VETO (ns)"}

set table(READOUTE) {readoutE int-widget->param param->int-widget "Energy.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Energy"}
set table(READOUTTAC) {readoutTAC int-widget->param param->int-widget "TAC.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TAC"}

set table(ENABLE-BGO-PATT-L) {enablebgopattl int-widget->param param->int-widget "BGOPattern.Low.ROEnable" 
   int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Pattern Low"}

set table(ENABLE-BGO-PATT-H) {enablebgopatth int-widget->param param->int-widget "BGOPattern.High.ROEnable" 
   int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Pattern High"}



#    Inspection line configuration  -  this format is for all modules EXCEPT Eurogam modules

#    for each item in the configuration  list
#    item 1    -   inspection line name
#    item 2    -   channel select 
#    item 3    -   parameter select

#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

set AI-Configuration [list       \
   {Disconnected       0   *}    \
   {Time-Ampl          *   1}    \
   {SUMO              20   1}    \
   {0V                21   1}    \
   {Gated-Int          *   2}    \
   {GISum             19   2}    \
]

set AI-BackParam      {0 32 52 53 64 83}

set DI-Configuration [list       \
   {Disconnected       0   *}    \
   {Fast_Trigger      32   1}    \
   {Validation        32   3}    \
   {Veto              32   4}    \
]

set DI-BackParam      {0 101 103 104}


set readoutitems {READOUTE READOUTTAC}

set channelitems {FTSAMPLE VALSAMPLE VETOADJ}

set segmentitems {ENABLE}


set info(CARD) " From this window you can setup the electronics for the BGO part of the Euroball Cluster detector VXI electronics.\n\
                Each VXI card contains 19 BGO electronics channels. 18 are connected to the shield of the Cluster detector.\n\
                The 19th channel is available as a spare. There is also a SUM channel."


