# xdc3214v.tcl---common code for XDC3214 cards

#     created 2/2/99  from QDC3214V card frame   VP

#set debug 0
#set started 0

#set frame ADC3214V
#set frametitle "ADC3214V Card Setup"
#set icontitle ADC3214V

#set cardtype ADC3214V
#set xdctype ADC

set VXIGlobal ""

set adclist ""
for {set i 0} {$i < 32} {incr i} {append adclist " $i"}
set seglist "$adclist *"
set chantype c

set segindex -1
set adc 0



#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL) {channel widget->channel channel->widget nil
        nil nil nil nil nil nil nil 1 nil}

for {set i 0} {$i < 32} {incr i} {
   set table(ENABLE$i) "enable$i int-widget->param param->int-widget \"c$i.Enable\"
       int-reg->param param->int-reg nil nil nil nil nil 0 \"Enable$i\""
}

for {set i 0} {$i < 4} {incr i} {
   set table(VXMSKVOIE$i) "vxmskvoie$i int-widget->param param->int-widget \"VXMSKVOIE$i\"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil"
}

set table(XDCSTATUS) {vxstatus str-widget->param param->hex-widget "VXSTATUS"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(XDCLABEL) {vxlabel str-widget->param param->hex-widget "Addr"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

set table(VXSIGLI1) {vxsigli1 int-widget->param param->int-widget "VXSIGLI1"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXSIGLI2) {vxsigli2 int-widget->param param->int-widget "VXSIGLI2"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXLT) {vxlt int-widget->param param->int-widget "VXLTVOIE"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXLI1) {vxli1 int-widget->param param->int-widget "VXLI1VOIE"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXLI2) {vxli2 int-widget->param param->int-widget "VXLI2VOIE"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXAI) {vxai int-widget->param param->int-widget "VXAIVOIE"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

set table(VXNIVTEST1) {vxnivtest1 int-widget->param param->int-widget "VXNIVTEST1"
       int-reg->param param->int-reg nil nil nil nil nil 0 "Test amplitude"}
set table(VXNIVA1) {vxniva1 int-widget->param param->int-widget "VXNIVA1"
       int-reg->param param->int-reg nil nil nil nil nil 0 "Integration gate"}
set table(VXNIVPV1) {vxnivpv1 int-widget->param param->int-widget "VXNIVPV1"
       int-reg->param param->int-reg nil nil nil nil nil 0 "Validation delay"}
set table(VXNIVB1) {vxnivb1 int-widget->param param->int-widget "VXNIVB1"
       int-reg->param param->int-reg nil nil nil nil nil 0 "Pedestal"}

set table(VXNIVTEST2) {vxnivtest2 int-widget->param param->int-widget "VXNIVTEST2"
       int-reg->param param->int-reg nil nil nil nil nil 0 "Test amplitude"}
set table(VXNIVA2) {vxniva2 int-widget->param param->int-widget "VXNIVA2"
       int-reg->param param->int-reg nil nil nil nil nil 0 "Integration gate"}
set table(VXNIVPV2) {vxnivpv2 int-widget->param param->int-widget "VXNIVPV2"
       int-reg->param param->int-reg nil nil nil nil nil 0 "Validation delay"}
set table(VXNIVB2) {vxnivb2 int-widget->param param->int-widget "VXNIVB2"
       int-reg->param param->int-reg nil nil nil nil nil 0 "Pedestal"}

set table(VXCODING) {vxcoding str-widget->param param->hex-widget "VXCODING"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXSYNCTST) {vxsynctst str-widget->param param->hex-widget "VXSYNCTST"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXINIT) {vxinit str-widget->param param->hex-widget "VXINIT"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXINHIBIT) {vxinhibit str-widget->param param->hex-widget "VXINHIBIT"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXREADOUT) {vxreadout str-widget->param param->hex-widget "VXREADOUT"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXWORK) {vxwork str-widget->param param->hex-widget "VXWORK"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXMRST) {vxmrst str-widget->param param->hex-widget "VXMRST"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXCT) {vxct str-widget->param param->hex-widget "VXCT"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VXVAL) {vxval str-widget->param param->hex-widget "VXVAL"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#    VXI Configuration Registers

set table(MODELCODE) {vximodcode str-widget->param param->hex-widget "VXI.ModelCode"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SERIALNUM) {vxiserialnum str-widget->param param->hex-widget "VXI.SerialNum"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MODLEVEL) {vximodlevel str-widget->param param->hex-widget "VXI.ModLevel"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MANID) {vximanid str-widget->param param->hex-widget "VXI.ManID"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(DEVICE) {vxidevice str-widget->param param->hex-widget "VXI.DevClass"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(ADDRSPACE) {vxiaddrspace str-widget->param param->hex-widget "VXI.AddrSpace"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(STATUS) {vxistatus str-widget->param param->hex-widget "VXI.Status"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(OFFSET) {vxioffset str-widget->param param->hex-widget "VXI.Offset"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(TERMINATION) {TERMINATION int-widget->param param->int-widget "Termination"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}


#    register selection for parameter save function

set registersavepatterns {
   VXCODING VXSYNCTST VXINIT VXINHIBIT VXREADOUT VXWORK VXMRST VXCT VXVAL
   VXNIVTEST1 VXNIVA1 VXNIVPV1 VXNIVB1 VXNIVTEST2 VXNIVA2 VXNIVPV2 VXNIVB2
}
for {set i 0} {$i < 32} {incr i} {append registersavepatterns " c$i.Enable"}


set logicinspmenu {
    disconnect ST INH* VAL CT* BUSY CODING READOUT RST CKCPTDAC OEVOIVAL16-1* OEVOIVAL32-17* \
    OUGATE INCRADR CONVA EOCA* CONVB EOCB* CONVC EOCC* CONVD EOCD* LATCHADRMUX \
    ENADCA* ENADCB* ENADCC* ENADCD* WRMEM DECVAI MODSEL LECTACQ OEBUSIN* OEBUSOUT* \
}


loadsource common.vxi

proc click-inspection {w i} {
    if {$i == 0} then {
       click-on $w 0
    } else { 
       click-on $w [expr 0x8000 + $i - 1]
    }
}

proc click-adc-inspection {w i} {
  global segindex adc

    if {$i == 0} then {
       set segindex $adc
       click-on $w 0
    } else { 
       set segindex 32
       click-on $w 0
       set segindex $adc
       click-on $w [expr 0x8000 + $i - 1]
    }
    set segindex -1
}

proc display-inspection {} {
  global logicinspmenu segindex adc
  
     set segindex -1

    set vl [expr 255 & [read-vxi-reg VXSIGLI1]]
    if {$vl == 0} then {
        :modify SIGLI1-USE :label "Disconnected"
    } else {
        :modify SIGLI1-USE :label [lindex $logicinspmenu [expr $vl + 1]]
    }

    set vl [expr 255 & [read-vxi-reg VXSIGLI2]]
    if {$vl == 0} then {
        :modify SIGLI2-USE :label "Disconnected"
    } else {
        :modify SIGLI2-USE :label [lindex $logicinspmenu [expr $vl + 1]]
    }

    set segindex $adc
    foreach w {LT LI1 LI2 AI} {
        :modify $w :value [expr [read-vxi-reg VX[set w]VOIE] >> 15]
    }
    set segindex -1
}

proc repaint-parameter {} {
   global segindex adc
   display-inspection
   set segindex $adc
   :modify LABEL :value [read-vxi-reg Addr]
   set segindex -1
}

proc click-enable {v} {
  switch $v {
      0   {for {set i 0} {$i < 4} {incr i} {click-on VXMSKVOIE$i 0}}
      1   {for {set i 0} {$i < 4} {incr i} {click-on VXMSKVOIE$i 255}}
  }
  click-redisplay
}

proc click arg {
   global debug adc
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      *REDISPLAY   {click-redisplay}
      ENGINEERING  {click-$v}

      CHANNEL     {click-channel $v}
      ADC         {set adc $v; repaint-parameter}

      SIGLI1 -
      SIGLI2      {click-inspection VX$w $i; display-inspection}

      AI  -
      LI1 -
      LI2 -
      LT          {click-adc-inspection VX$w $v; display-inspection}

      XDCSTATUSW  {click-on XDCSTATUS $v; click-redisplay}

      default     {click-on $w $v}
   }
}


set electronicsframe "[self frame-name].electronics"
set electronicsvisible 0

proc make-frame1 {} {
  global env xdctype chanlist adclist
  global logicinspmenu

  :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

   :panel P1 :layout T :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 5

      :choice-stack CHANNEL :label "Current Module:" :strings $chanlist :valuex 18c
      :choice-stack ADC     :label "Current $xdctype:"     :strings $adclist :valuex 18c
      :next-row T
      :message ENABLEM  :label "$xdctype enable" :bold T
      :button ENABLE    :label "Enable All"  :command "click-enable 1"
      :button DISABLE   :label "Disable All" :command "click-enable 0"
      :text    LABEL    :label "Label" :w 8 :valuex 8c :deaf T
      :next-row T
      :row-gap 0; :col-gap 0
      set j 0
      for {set i 0} {$i < 32} {incr i} {
         :checkbox ENABLE$i :label $i :valuex 3c 
         incr j
         if {$j == 8} then {:next-row T; set j 0}
      }
      
   :panel P3 :layout T :padx 10 
     :layout V; :row-gap 5
     :message GP1 :label "Group 1: [set xdctype]s 0 => 15"
      :slider VXNIVPV1  :label "Validation delay:" :min 0 :max 4095   :valuex 20c
if {$xdctype == "QDC"} then {
      :slider VXNIVA1   :label "Integration gate:" :min 0 :max 4095   :valuex 20c
      :slider VXNIVB1   :label "Pedestal:"         :min 0 :max 4095   :valuex 20c
}
if {$xdctype == "ADC"} then {
      :slider VXNIVA1   :label "Gate duration:" :min 0 :max 4095   :valuex 20c
      :slider VXNIVB1   :label "Threshold:"         :min 0 :max 4095   :valuex 20c
}
if {$xdctype == "TDC"} then {
      :slider VXNIVA1   :label "Time range:" :min 0 :max 4095   :valuex 20c
      :checkbox VXNIVB1   :label "Times 8 multipler:"    :valuex 20c
}

     :message GP2 :label "Group 2: [set xdctype]s 16 => 31"
      :slider VXNIVPV2  :label "Validation delay:" :min 0 :max 4095   :valuex 20c
if {$xdctype == "QDC"} then {
      :slider VXNIVA2   :label "Integration gate:" :min 0 :max 4095   :valuex 20c
      :slider VXNIVB2   :label "Pedestal:"         :min 0 :max 4095   :valuex 20c
}
if {$xdctype == "ADC"} then {
      :slider VXNIVA2   :label "Gate duration:" :min 0 :max 4095   :valuex 20c
      :slider VXNIVB2   :label "Threshold:"         :min 0 :max 4095   :valuex 20c
}
if {$xdctype == "TDC"} then {
      :slider VXNIVA2   :label "Time range:" :min 0 :max 4095   :valuex 20c
      :checkbox VXNIVB2   :label "Times 8 multipler:"    :valuex 20c
}

   :panel P4 :layout T :padx 10 :pady 10
      :layout V; :row-gap 5

     :message INSPM :label "Inspection line control" :bold T

      :checkbox LT  :label "Enable $xdctype Val point on line LT"      :valuex 36c
      :checkbox LI1 :label "Enable $xdctype signal ECTRLi on line LI1" :valuex 36c
      :checkbox LI2 :label "Enable $xdctype signal ECTRLi on line LI2" :valuex 36c
      :checkbox AI  :label "Enable $xdctype signal ANALOGi on line AI" :valuex 36c

      :layout H; :row-gap 10
      :next-row T     
      :menubutton SIGLI1 :label "logic inspection LI1:"  :w 22 :menu $logicinspmenu
      :message SIGLI1-USE   :label ""
      :next-row T
      :menubutton SIGLI2 :label "logic inspection LI2:"  :w 22 :menu $logicinspmenu
      :message SIGLI2-USE   :label ""

   :panel P5 :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 30; :row-gap 5
      :button REDISPLAY
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :button HELP  
   
 :show T

}

proc make-frame2 {} {}


proc make-electronics {} {
  global env electronicsframe electronicsvisible
  global cardtype

  :frame "$electronicsframe" :label "$cardtype Electronics" :show-footer T :resize F :transient T

    :panel ELECTRONICSPANEL :layout T :padx 5 :pady 5
     :layout H; :row-gap 5

      :message ELM1       :label "VXI Configuration Registers" :bold T
      :next-row T
      :text MANID         :label "Manufacturer ID:"    :w 6  :read-only T   :valuex 20c
      :text DEVICE        :label "Device Class:"       :w 6  :read-only T   :valuex 20c
      :next-row T
      :text ADDRSPACE     :label "Address Space:"      :w 6  :read-only T   :valuex 20c
      :text MODELCODE     :label "Model Code:"         :w 6  :read-only T   :valuex 20c
      :next-row T
      :text SERIALNUM     :label "Serial Number:"      :w 6  :read-only T   :valuex 20c
      :text MODLEVEL      :label "Modification Level:" :w 6  :read-only T   :valuex 20c
      :next-row T
      :text STATUS        :label "Status Register"     :w 6  :read-only T   :valuex 20c
      :text OFFSET        :label "Offset Register"     :w 6  :read-only T   :valuex 20c
      :next-row T
      :text TERMINATION   :label "Termination"  :w 3   :valuex 20c
      :next-row T

      :message ELM2       :label "Board Configuration Registers" :bold T
      :next-row T
      :text VXSYNCTST     :label VXSYNCTST   :w 8    :valuex 18c
      :text VXINIT        :label VXINIT      :w 8    :valuex 18c
      :next-row T
      :text VXINHIBIT     :label VXINHIBIT   :w 8    :valuex 18c
      :text VXCODING      :label VXCODING    :w 8    :valuex 18c
      :next-row T
      :text VXREADOUT     :label VXREADOUT   :w 8    :valuex 18c
      :text VXWORK        :label VXWORK      :w 8    :valuex 18c
      :next-row T
      :text VXMRST        :label VXMRST      :w 8    :valuex 18c
      :text VXCT          :label VXCT        :w 8    :valuex 18c
      :next-row T
      :text VXVAL         :label VXVAL       :w 8    :valuex 18c
      :next-row T

      :message ELM3       :label "Test Pulse Amplitude" :bold T
      :next-row T
   :slider VXNIVTEST1  :label "Group 1:" :min 0 :max 4095  :valuex 20c
      :next-row T
   :slider VXNIVTEST2  :label "Group 2:" :min 0 :max 4095 :valuex 20c
      :next-row T

      :message ELM4       :label "Board Status/Control Register" :bold T
      :next-row T
      :text XDCSTATUS     :label "STATUS (read)"  :w 8 :valuex 18c :deaf T
      :text XDCSTATUSW    :label "STATUS (write)" :w 8 :valuex 18c 
  
      :show T
   set electronicsvisible 1
}  
